/* tips.c generated by valac 0.16.1, the Vala compiler
 * generated from tips.vala, do not modify */

/*
 * DESCRIPTION      Tip struct and tips static data
 * PROJECT          Mind Map Architect
 * AUTHOR           Ondrej Tuma <mcbig@zeropage.cz>
 *
 * Copyright (C) Ondrej Tuma 2011
 * Code is present with BSD licence.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_TIP_CATEGORY (tip_category_get_type ())

#define TYPE_TIP (tip_get_type ())
typedef struct _Tip Tip;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	TIP_CATEGORY_APP,
	TIP_CATEGORY_MINDMAP
} TipCategory;

struct _Tip {
	guint category;
	gchar* title;
	gchar* body;
};



GType tip_category_get_type (void) G_GNUC_CONST;
GType tip_get_type (void) G_GNUC_CONST;
Tip* tip_dup (const Tip* self);
void tip_free (Tip* self);
void tip_copy (const Tip* self, Tip* dest);
void tip_destroy (Tip* self);
void tip_init (Tip *self, const gchar* title, const gchar* body, guint category);
Tip* get_tips (int* result_length1);
static void _vala_Tip_array_free (Tip* array, gint array_length);


GType tip_category_get_type (void) {
	static volatile gsize tip_category_type_id__volatile = 0;
	if (g_once_init_enter (&tip_category_type_id__volatile)) {
		static const GEnumValue values[] = {{TIP_CATEGORY_APP, "TIP_CATEGORY_APP", "app"}, {TIP_CATEGORY_MINDMAP, "TIP_CATEGORY_MINDMAP", "mindmap"}, {0, NULL, NULL}};
		GType tip_category_type_id;
		tip_category_type_id = g_enum_register_static ("TipCategory", values);
		g_once_init_leave (&tip_category_type_id__volatile, tip_category_type_id);
	}
	return tip_category_type_id__volatile;
}


void tip_init (Tip *self, const gchar* title, const gchar* body, guint category) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_;
	g_return_if_fail (title != NULL);
	g_return_if_fail (body != NULL);
	memset (self, 0, sizeof (Tip));
	_tmp0_ = title;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*self).title);
	(*self).title = _tmp1_;
	_tmp2_ = body;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*self).body);
	(*self).body = _tmp3_;
	_tmp4_ = category;
	(*self).category = _tmp4_;
}


void tip_copy (const Tip* self, Tip* dest) {
	guint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = (*self).category;
	(*dest).category = _tmp0_;
	_tmp1_ = (*self).title;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 ((*dest).title);
	(*dest).title = _tmp2_;
	_tmp3_ = (*self).body;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 ((*dest).body);
	(*dest).body = _tmp4_;
}


void tip_destroy (Tip* self) {
	_g_free0 ((*self).title);
	_g_free0 ((*self).body);
}


Tip* tip_dup (const Tip* self) {
	Tip* dup;
	dup = g_new0 (Tip, 1);
	tip_copy (self, dup);
	return dup;
}


void tip_free (Tip* self) {
	tip_destroy (self);
	g_free (self);
}


GType tip_get_type (void) {
	static volatile gsize tip_type_id__volatile = 0;
	if (g_once_init_enter (&tip_type_id__volatile)) {
		GType tip_type_id;
		tip_type_id = g_boxed_type_register_static ("Tip", (GBoxedCopyFunc) tip_dup, (GBoxedFreeFunc) tip_free);
		g_once_init_leave (&tip_type_id__volatile, tip_type_id);
	}
	return tip_type_id__volatile;
}


static void _vala_Tip_array_free (Tip* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			tip_destroy (&array[i]);
		}
	}
	g_free (array);
}


Tip* get_tips (int* result_length1) {
	Tip* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	Tip _tmp2_ = {0};
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	Tip _tmp5_ = {0};
	Tip* _tmp6_ = NULL;
	Tip* tips;
	gint tips_length1;
	gint _tips_size_;
	Tip* _tmp7_;
	gint _tmp7__length1;
	_tmp0_ = _ ("Moving with Ideas");
	_tmp1_ = _ ("You can move with ideas by key shortcuts. You can use CTRL - Arrow UP," \
" Down, Left or Right to move with selected Ideas.");
	tip_init (&_tmp2_, _tmp0_, _tmp1_, (guint) TIP_CATEGORY_APP);
	_tmp3_ = _ ("Using Mind Maps as TODO list");
	_tmp4_ = _ ("Mind Maps could be use as TODO lists. You have more tree like possibil" \
"ity with mind maps, like categories, importance or difficulty.");
	tip_init (&_tmp5_, _tmp3_, _tmp4_, (guint) TIP_CATEGORY_MINDMAP);
	_tmp6_ = g_new0 (Tip, 2);
	_tmp6_[0] = _tmp2_;
	_tmp6_[1] = _tmp5_;
	tips = _tmp6_;
	tips_length1 = 2;
	_tips_size_ = tips_length1;
	_tmp7_ = tips;
	_tmp7__length1 = tips_length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}



